SystemOrganization addCategory: #MooseExecutionAnalyzer!
SystemOrganization addCategory: #'MooseExecutionAnalyzer-AutomaticalCaseStudies'!
SystemOrganization addCategory: #'MooseExecutionAnalyzer-Tests'!
SystemOrganization addCategory: #'MooseExecutionAnalyzer-TestsScenarios'!

TestCase subclass: #ATest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!ATest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 14:55'!
test
	A new foo! !

!ATest methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:12'!
testBasic
	self assert: A new foo notNil! !

TestCase subclass: #CreateFigureTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!CreateFigureTests methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/3/2012 15:25'!
testFigures
	|create|
	create:=CreateFigures new.
	create create.
	self assert: create notNil.! !

TestCase subclass: #MooseExecutionSimpleInvocationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-Tests'!

!MooseExecutionSimpleInvocationTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/23/2012 15:08'!
createMooseModelFromPackage
	|packages task importer mooseModel|
"	
	importer:=MooseSqueakClassPackageImporterTask new.
	mooseModel := MooseModel new.
	importer
		importingContext: self createImportingContext;
		model: mooseModel;
		addFromPackagesNamed: #('MooseExecutionAnalyzer-TestsScenarios');
		candidateClass: self candidateListOperatorClass ;
		runWithProgress."
	packages := #('MooseExecutionAnalyzer-TestsScenarios').

       mooseModel := MooseModel new.
       task := MooseSqueakClassCategoryImporterTask new.
       task importerClass: SmalltalkImporter.
       task importingContext mergeClassAndMetaclass.
       task model: mooseModel.
       task runCandidateOperator.
       task addFromPackagesNamed: packages.
       task runWithProgress.
	^mooseModel.! !

!MooseExecutionSimpleInvocationTest methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/4/2012 18:25'!
testDependenciesInHierarchy1
	"This test checks that if a method is ioverwritten in all the children of a hierarchy, and all the overwritten methods are covered by the test, the dependencies should be computed only for the father"

	| mooseModel aFAMIXMethod |
	mooseModel:=self createMooseModelFromPackage.

	aFAMIXMethod:=(mooseModel allMethods) detect: [ :famixMethod | famixMethod name = #create
								and: [ famixMethod parentType name = #CreateFigures ] ].

	"There are 2 implementors of create:"
	self assert: (aFAMIXMethod outgoingInvocations at: 1) candidates size = 2. 
	self assert: (aFAMIXMethod outgoingInvocations at: 3) candidates size = 2. 

	MooseExecutionProfiler refineModel: mooseModel.
	
	self assert: aFAMIXMethod outgoingInvocations size =4.
	self assert: (aFAMIXMethod outgoingInvocations at: 2) candidates size =0. "The new invocation"
	self assert: (aFAMIXMethod outgoingInvocations at: 4) candidates size =0. "The new invocation"
	self assert: (aFAMIXMethod outgoingInvocations at: 1) candidates size =1. "The drawOn invocation of the parent"
	self assert: (aFAMIXMethod outgoingInvocations at: 3) candidates size =1. "The drawOn invocation of the parent"
	self assert: ((aFAMIXMethod outgoingInvocations at: 1) candidates at: 1) parentType name = #Figure.
	self assert: ((aFAMIXMethod outgoingInvocations at: 3) candidates at: 1) parentType name = #Figure.! !

!MooseExecutionSimpleInvocationTest methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/3/2012 15:01'!
testDependenciesInHierarchy2
	"This test checks that if a method is ioverwritten in only some of the children of a hierarchy, the dependencies should be computed as usual"

	| mooseModel aFAMIXMethod |
	mooseModel:=self createMooseModelFromPackage.

	aFAMIXMethod:=(mooseModel allMethods) detect: [ :famixMethod | famixMethod name = #drawOn:
								and: [ famixMethod parentType name = #NiceGUI ] ].

	"There are 3 implementors of drawOn:"
	self assert: (aFAMIXMethod outgoingInvocations at: 1) candidates size = 3. 

	MooseExecutionProfiler refineModel: mooseModel.
	
	self assert: aFAMIXMethod outgoingInvocations size =2.
	self assert: (aFAMIXMethod outgoingInvocations at: 2) candidates size =0. "The new invocation"
	self assert: (aFAMIXMethod outgoingInvocations at: 1) candidates size =1. "The drawOn invocation"
	self assert: ((aFAMIXMethod outgoingInvocations at: 1) candidates at: 1) parentType name = #Button.! !

!MooseExecutionSimpleInvocationTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/23/2012 15:08'!
testSimpleInvocation
"This test checks the simplest case in which a class 'A' calls a method 'zork' that it is implemented in two classes 'B' and 'C'. However, 'A' only calls the 'B' class method"
	| mooseModel aFAMIXMethod |
	mooseModel:=self createMooseModelFromPackage.
	MooseExecutionProfiler refineModel: mooseModel.
	aFAMIXMethod:=mooseModel allMethods 
		detect: [ :famixMethod | famixMethod name = #foo
								and: [ famixMethod parentType name = #A ] ].
	self assert: aFAMIXMethod outgoingInvocations size =2.
	self assert: (aFAMIXMethod outgoingInvocations at: 2) candidates size =1. "The foo invocation"
	self assert: (aFAMIXMethod outgoingInvocations at: 1) candidates size =0. "The new invocation"
	self assert: ((aFAMIXMethod outgoingInvocations at: 2) candidates at: 1) parentType name = #B.! !

TestCase subclass: #NiceGUITest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!NiceGUITest methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:43'!
testDrawing
| gui canvas |
	gui := NiceGUI new.
	canvas := Canvas new.
	gui drawOn: canvas.
	self assert: gui notNil.! !

!MooseModel methodsFor: '*mooseexecutionanalyzer' stamp: 'SantiagoVidal 1/21/2012 14:38'!
runTests
	<menuItem: 'Refine model by running tests' category: 'Utilities'>
	MooseExecutionProfiler refineModel: self.
! !

MethodSpy subclass: #MooseExecutionMethod
	instanceVariableNames: 'calledMethods isCovered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer'!

!MooseExecutionMethod methodsFor: 'hooks' stamp: 'AlexandreBergel 1/18/2012 11:33'!
beforeRun: methodName with: listOfArguments in: receiver
	| c |
	isCovered := true.
	c := self callingMethod.
	c isSpy ifTrue: [ 
		c methodSpy calledMethods add: self ] ! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/4/2012 18:09'!
belongsToAProfiledHierarchy: aMethod
	"This methods checks if aMethod overwrites an inmediate father method and if all the brother classes that overwrites the method were profiled"
	|fatherClass fatherMethod|	
	fatherClass:= aMethod parentType superclass.
	fatherMethod:=self method: aMethod isOverwrittingIn: fatherClass.
	(fatherMethod ==nil) ifFalse:[
		fatherClass subclassHierarchy do:[:subClass|
			(subClass understands: aMethod signature) ifTrue:[
				(self hasCallerFor: (self methodWith: (aMethod signature) in:subClass ))ifFalse:[^nil.].
			].
		].
		^fatherMethod.
	].
	^nil.! !

!MooseExecutionMethod methodsFor: 'accessing' stamp: 'AlexandreBergel 5/6/2011 07:21'!
calledMethods
	^ calledMethods! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 13:23'!
getFamixMethodIn: aMooseModel
	"Return the famix methods contained in the model that corresponds to myself (i.e., same selector and same class name)"
	^ aMooseModel allMethods 
		detect: [ :famixMethod | famixMethod name = self selector
								and: [ famixMethod parentType name == self classSpy className ] ]
		ifNone: [ nil ]! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 14:25'!
hasAnyCallerFor: famixMethod
	"Return true if a method corresponding to the method has been profiled"

	^ calledMethods anySatisfy: [ :spyMethod |
			(spyMethod selector == famixMethod name) 
				and: [ spyMethod classSpy className = famixMethod parentType name ]
			]! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 11:30'!
hasCalledMethod
	^ self calledMethods notEmpty! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 15:09'!
hasCallerFor: famixMethod
	"Return true if a method corresponding to the method has been profiled"

	^ calledMethods anySatisfy: [ :spyMethod |
			(spyMethod selector == famixMethod name) 
				and: [ spyMethod classSpy className = famixMethod parentType name ]
			]! !

!MooseExecutionMethod methodsFor: 'initialize-release' stamp: 'SantiagoVidal 1/27/2012 22:00'!
initialize 
	super initialize.
	calledMethods := BoundedIdentitySet maxSize: 100.
	isCovered := false.
	! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 11:34'!
isCovered
	^ isCovered! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 14:43'!
matchingCandidatesFor: famixInvocation
	"Return the list of candidates of the invocation that correspond to a called method"
	
	| matchingCandidates |
	matchingCandidates := OrderedCollection new.
	famixInvocation candidates do: [ :famixMethod | 
		(self hasAnyCallerFor: famixMethod) ifTrue: [ matchingCandidates add: famixMethod ]
	].
	^ matchingCandidates! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/4/2012 17:28'!
method: aMethod isOverwrittingIn: aFatherClass
	(aFatherClass isInterface) ifFalse:[
		aFatherClass methodsDo: [:aFatherMethod|
			((aMethod signature)match:(aFatherMethod signature) )ifTrue:[
				^aFatherMethod.
			].
		].
	].
	^nil.! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/4/2012 17:50'!
methodWith: methodName in: aClass
	aClass methodsDo: [:aMethod|
			(methodName match:(aMethod signature) )ifTrue:[
				^aMethod.
			].
		].! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/4/2012 17:59'!
refineInvocation: famixInvocation
	"Refine the candidate of the invocation according to what has been captured during the profiling"
	
	"If no candidate, then we do nothing"
	famixInvocation candidates ifEmpty: [ ^ self ].
	
	"We check if at least the selector match"
	"If no, then we do nothing""This checks if the call was used in the test"
	(calledMethods anySatisfy: [ :spyM | spyM selector == famixInvocation candidates first name ]) ifFalse: [ ^ self ].
	
	"self haltIf: [ famixInvocation candidates size > 1 ]."
	famixInvocation candidates copy do: [ :famixMethod | 
		(self hasCallerFor: famixMethod) "Ensure that the method call is of the same class"
			ifFalse: [ famixInvocation candidates remove: famixMethod ]
			ifTrue:["Aca hay que fijarse si el netodo es overwritten. Si es asi, mirar que hermanos lo sobreescriben tambien. Si todos los hermanos que lo sobreescriben fueron profiled eliminar como candidate y cambiarlo por el padre"
				|fatherOverridenMethod|
				fatherOverridenMethod:=self belongsToAProfiledHierarchy: famixMethod.
				(fatherOverridenMethod==nil)ifFalse:[
					famixInvocation candidates remove: famixMethod.
					famixInvocation candidates add:fatherOverridenMethod.
				]
			].
	].

 ! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 15:17'!
refineMethod: famixMethod
	"We remove the invocations wrongly computed in famixMethod"
	famixMethod outgoingInvocations do: [ :famixInvocation | 
		self refineInvocation: famixInvocation
	]. 
! !

!MooseExecutionMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 15:17'!
refineModel: aMooseModel
	| famixMethod |
	
	"Do nothing if I have not been covered (i.e., not executed during the unit tests execution)"
	self isCovered ifFalse: [ ^ self ].
	
	"We get the famix method that corresponds to myself"
	famixMethod := self getFamixMethodIn: aMooseModel.
	
	"We now remove all the invocation wrongly computed by the smalltalk importer"
	"We have to check there is a method that correspond to myself. If none, then we do nothing"
	famixMethod ifNotNil: [ self refineMethod: famixMethod.]! !

AbstractSpyTest subclass: #EjemploTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer'!

!EjemploTest methodsFor: 'hooks' stamp: 'SantiagoVidal 1/24/2012 09:42'!
profilerClass
	^  Ejemplo! !

AbstractSpyTest subclass: #MooseExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-Tests'!

!MooseExecutionTest methodsFor: 'hooks' stamp: 'AlexandreBergel 5/6/2011 07:20'!
profilerClass
	^ MooseExecutionProfiler  ! !

!MooseExecutionTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/6/2011 07:41'!
testBasic
	| profiler |
	profiler := self runScenario.
	self assert: ((profiler >> #TGCarExampleTest>>#testBasic) calledMethods includesAllOf: 
					{profiler >> #TGCar>>#carName: .
					 profiler >> #TGCar>>#addWheel: .
					 profiler >> #TGCar>>#driver: .
					}).
	self assert: (profiler >> #TGCar >> #addWheel:) calledMethods isEmpty.
	self assert: (profiler >> #TGCar >> #hasDriver) calledMethods isEmpty.
	self assert: ((profiler >> #TGDriver >> #isMale) calledMethods isEmpty).
	self assert: ((profiler >> #TGMaleDriver >> #isMale) calledMethods isEmpty).
	self assert: ((profiler >> #TGCar >> #giveMeANewCarForDriver:) calledMethods
					 includes: (profiler >> #TGMaleDriver >> #isMale)).
! !

PackageSpy subclass: #MooseExecutionPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer'!

!MooseExecutionPackage class methodsFor: 'hooks' stamp: 'AlexandreBergel 5/5/2011 21:50'!
spyClassForClass
	 ^ MooseExecutionClass! !

ClassSpy subclass: #MooseExecutionClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer'!

!MooseExecutionClass class methodsFor: 'hooks' stamp: 'AlexandreBergel 5/5/2011 21:50'!
spyClassForMethod
	 ^ MooseExecutionMethod! !

Profiler subclass: #MooseExecutionProfiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer'!

!MooseExecutionProfiler class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 1/18/2012 11:23'!
fd! !

!MooseExecutionProfiler class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 14:06'!
refineModel: aMooseModel
	"Public method"

	| packages|
	packages := aMooseModel allPackages asArray collect: [:p | p name asString ].
	
	(self runTestsForPackages: packages) refineModel: aMooseModel.! !

!MooseExecutionProfiler class methodsFor: 'hooks' stamp: 'AlexandreBergel 5/5/2011 21:50'!
spyClassForPackage
	 ^ MooseExecutionPackage! !

!MooseExecutionProfiler methodsFor: 'visualization' stamp: 'SantiagoVidal 1/21/2012 14:26'!
refineModel: aMooseModel
	"main public method. This method has to be run after the profiling has been realized"
	self allMethods do: [ :m| m refineModel: aMooseModel ]! !

!MooseExecutionProfiler methodsFor: 'visualization' stamp: 'AlexandreBergel 5/5/2011 21:50'!
visualizeOn: view
	view nodes: self allClasses forEach: [ :each | 
		view nodes: each methods.
		view gridLayout gapSize: 2.
	].
	view edgesFrom: #superclass.
	view treeLayout
	! !

Object subclass: #A
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!A methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:11'!
foo
	| object |
 	object := B new.
 	object zork! !

Object subclass: #B
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!B methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:12'!
zork
	 ^ 1! !

Object subclass: #C
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!C methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:12'!
zork
 	^ 2! !

Object subclass: #CreateFigures
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!CreateFigures methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/3/2012 15:16'!
create
	FCircle new show.
	FRectangle new show.! !

Object subclass: #Figure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

Figure subclass: #FCircle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!FCircle methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/3/2012 15:11'!
show
	"Show a circle"! !

Figure subclass: #FRectangle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!FRectangle methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/3/2012 15:11'!
show
	"show a rectangle"! !

!Figure methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 3/3/2012 15:10'!
show
	self subclassResponsibility.! !

Object subclass: #MooseEACaseStudy
	instanceVariableNames: 'averageOfCandidates1st averageOfCandidates2nd packageRegularExpression explicitPackages mooseModel packages averageOfFalsePositivesForInvocation1st averageOfFalsePositivesForInvocation2nd averageOfOutgoingInvocationsByMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-AutomaticalCaseStudies'!

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 1/28/2012 13:24'!
arkiCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('Arki-Reporter-Browser' 'Arki-Reporter-Core' 'Arki-Tests-Reporter').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 2/1/2012 14:21'!
autoTestCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('Autotest-Core' 'Autotest-GUI' 'Autotest-Help' 'Autotest-Tests-Core' 'Autotest-Tests-GUI').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'calculation' stamp: 'SantiagoVidal 3/5/2012 15:22'!
averageOfCandidatesByOutgoingInvocation
	|totalOutgoingInvocations totalCandidates|
	totalOutgoingInvocations:=0.
	totalCandidates:=0.
	mooseModel allMethods do:[:aFAMIXMethod |
		totalOutgoingInvocations:=totalOutgoingInvocations+aFAMIXMethod outgoingInvocations size.
		aFAMIXMethod outgoingInvocations do: [ :famixInvocation | 
			totalCandidates:=totalCandidates+famixInvocation candidates size.
		].
	].
	^(totalCandidates/totalOutgoingInvocations)asFloat.! !

!MooseEACaseStudy methodsFor: 'calculation' stamp: 'SantiagoVidal 3/5/2012 16:01'!
averageOfOutgoingInvocationsByMethod
	|totalOutgoingInvocations totalMethods|
	totalOutgoingInvocations:=0.
	totalMethods:=mooseModel allMethods size.
	mooseModel allMethods do:[:aFAMIXMethod |
		totalOutgoingInvocations:=totalOutgoingInvocations+aFAMIXMethod outgoingInvocations size.
	].
	^(totalOutgoingInvocations/totalMethods)asFloat.! !

!MooseEACaseStudy methodsFor: 'calculation' stamp: 'SantiagoVidal 3/5/2012 15:57'!
calculate
	"Create the Moose Model"	
	self createMooseModel.
	
	"Calculate average of candidates by outgoing invocation"
	averageOfCandidates1st:=self averageOfCandidatesByOutgoingInvocation.
	averageOfFalsePositivesForInvocation1st:=self calculateFalsePositivesForInvocation. 
	averageOfOutgoingInvocationsByMethod:=self averageOfOutgoingInvocationsByMethod.
	"Refine model"
	MooseExecutionProfiler refineModel: mooseModel.
	
	"Calculate average of candidates by outgoing invocation after refining the model"
	averageOfCandidates2nd:=self averageOfCandidatesByOutgoingInvocation.
	averageOfFalsePositivesForInvocation2nd:=self calculateFalsePositivesForInvocation.
	"Print results"
	self printResults.! !

!MooseEACaseStudy methodsFor: 'calculation' stamp: 'SantiagoVidal 3/5/2012 15:33'!
calculateFalsePositivesForInvocation
	|numberOfInvocationsWithCandidates acumulatePercentageOfFalsePositivesForInvocationCandidates|
	acumulatePercentageOfFalsePositivesForInvocationCandidates:=0.
	numberOfInvocationsWithCandidates:=0.
	mooseModel allMethods do:[:aFAMIXMethod |
		aFAMIXMethod outgoingInvocations do: [ :famixInvocation | 
			|candidateSize|
			candidateSize:=famixInvocation candidates size.
			(candidateSize>0)ifTrue:[
				numberOfInvocationsWithCandidates:=numberOfInvocationsWithCandidates +1.
				acumulatePercentageOfFalsePositivesForInvocationCandidates:=acumulatePercentageOfFalsePositivesForInvocationCandidates+((candidateSize-1)/candidateSize).
			].
		].
	].
	^(acumulatePercentageOfFalsePositivesForInvocationCandidates/numberOfInvocationsWithCandidates)asFloat.! !

!MooseEACaseStudy methodsFor: 'calculation' stamp: 'SantiagoVidal 1/28/2012 12:22'!
createMooseModel
	|task|
	
	mooseModel := MooseModel new.
	task := MooseSqueakClassCategoryImporterTask new.
      task importerClass: SmalltalkImporter.
      task importingContext mergeClassAndMetaclass.
      task model: mooseModel.
      task runCandidateOperator.
	(packageRegularExpression =nil) 
		ifTrue:[packages:=explicitPackages ] 
		ifFalse: [packages:=(Profiler packageNamesMatching: packageRegularExpression)].
      task addFromPackagesNamed: packages.
      task runWithProgress.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 3/4/2012 19:07'!
eyeSeeCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'EyeSee'; 
	package: 'ConfigurationOfEyeSee';load.
	(Smalltalk at: #ConfigurationOfEyeSee) project lastVersion load."""
	
	packageRegularExpression:="'EyeSee-*'."nil.
	explicitPackages:=#('EyeSee-Core' 'EyeSee-Axis' 'EyeSee-Events' 'EyeSee-Support' 'EyeSee-Tests-Core').
	
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 1/28/2012 13:11'!
fameCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('Fame-Core' 'Fame-Tests-Core' 'Fame-SmalltalkBinding' 'Fame-Example' 'Fame-ImportExport' 'Fame-Util').
	
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 1/28/2012 12:33'!
famixCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Famix'; 
	package: 'ConfigurationOfRFamix';load.
	(Smalltalk at: #ConfigurationOfFamix) project lastVersion load."
	
	packageRegularExpression:="'Famix-*'"nil.
	explicitPackages:=#('Famix-Tests-C' 'Famix-Extensions' 'Famix-SourceAnchor' 'Famix-Tests-Core' 'Famix-Tests-Extensions' 'Famix-Core' 'Famix-Implementation' 'Famix-Tests-Java' 'Famix-Smalltalk' 'Famix-Implementation-Tests' 'Famix-C' 'Famix-Java' 'Famix-Specifications' 'Famix-File').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 2/1/2012 14:14'!
finderCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('Finder-Core' 'Finder-Tests' 'Finder-UI').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 2/1/2012 14:17'!
fsCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('FS-FileStream' 'FS-AnsiStreams' 'FS-Core-Public' 'FS-Core' 'FS-Tests-Memory' 'FS-Tests-Core' 'FS-Disk' 'FS-Tests-AnsiStreams' 'FS-Tests-Disk' 'FS-Zip' 'FS-Memory' 'FS-Core-Kernel').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies-Not Working' stamp: 'SantiagoVidal 1/28/2012 14:44'!
fuelCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Fuel'; 
	package: 'ConfigurationOfFuel';load.
	(Smalltalk at: #ConfigurationOfFuel) project lastVersion load."
	
	packageRegularExpression:="'Fuel-*'"nil.
	explicitPackages:=#('Fuel-Collections' 'Fuel-Core' 'Fuel-Core-Clusters' 'Fuel-Core-Errors' 'Fuel-Core-Mappers' 'Fuel-Streams' 'Fuel-Utilities' "'FuelFameExtension' 'FuelFameExtension-Core' 'FuelFameExtension-Core-Clusters' 'FuelFameExtension-Core-Mappers' 'FuelFameExtension-Tests' 'FuelMooseExtension-Container' 'FuelMooseExtension-Container-Tests' 'FuelMooseExtension-Finder' 'FuelMooseExtension-Tests' 'FuelContainer' 'FuelContainer-Tests' "'FuelTests' 'FuelTests-Collections').
	
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 1/28/2012 14:52'!
fuelContainerCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Fuel'; 
	package: 'ConfigurationOfFuel';load.
	(Smalltalk at: #ConfigurationOfFuel) project lastVersion load."
	
	packageRegularExpression:="'Fuel-*'"nil.
	explicitPackages:=#('FuelContainer' 'FuelContainer-Tests').
	
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies-Not Working' stamp: 'SantiagoVidal 1/28/2012 14:45'!
fuelFameExtensionCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Fuel'; 
	package: 'ConfigurationOfFuel';load.
	(Smalltalk at: #ConfigurationOfFuel) project lastVersion load."
	
	packageRegularExpression:="'Fuel-*'"nil.
	explicitPackages:=#('FuelFameExtension' 'FuelFameExtension-Core' 'FuelFameExtension-Core-Clusters' 'FuelFameExtension-Core-Mappers' 'FuelFameExtension-Tests' "'FuelMooseExtension-Container' 'FuelMooseExtension-Container-Tests' 'FuelMooseExtension-Finder' 'FuelMooseExtension-Tests' 'FuelContainer' 'FuelContainer-Tests' ").
	
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies-Not Working' stamp: 'SantiagoVidal 1/28/2012 14:50'!
fuelMooseExtensionCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Fuel'; 
	package: 'ConfigurationOfFuel';load.
	(Smalltalk at: #ConfigurationOfFuel) project lastVersion load."
	
	packageRegularExpression:="'Fuel-*'"nil.
	explicitPackages:=#('FuelMooseExtension-Container' 'FuelMooseExtension-Container-Tests' 'FuelMooseExtension-Finder' 'FuelMooseExtension-Tests' "'FuelContainer' 'FuelContainer-Tests' ").
	
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 1/28/2012 14:42'!
fuelProgressUpdateCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Fuel'; 
	package: 'ConfigurationOfFuel';load.
	(Smalltalk at: #ConfigurationOfFuel) project lastVersion load."
	
	packageRegularExpression:="'Fuel-*'"nil.
	explicitPackages:=#('FuelProgressUpdate' 'FuelProgressUpdate-Tests').
	
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 2/1/2012 09:49'!
glamoroustCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('GT-ClassicCoder' 'GT-Coder' 'GT-Debugger' 'GT-Inspector' 'GT-Model' 'GT-Playground' 'GT-Tests-Inspector' 'GT-Tools' 'GT-Tools-Prototypes' 'GT-Tools-Utils').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 2/1/2012 15:08'!
glamourCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Glamour'; 
	package: 'ConfigurationOfGlamour';load.
	(Smalltalk at: #ConfigurationOfGlamour) project lastVersion load."
	
	packageRegularExpression:="'Glamour-*'"nil.
	explicitPackages:=#('Glamour-Tools' 'Glamour-Morphic-Renderer-Spotter' 'Glamour-Browsers' 'Glamour-Core' 'Glamour-Presentations' 'Glamour-Morphic-Renderer' 'Glamour-Morphic-Theme' 'Glamour-Announcements' 'Glamour-Mondrian-Presentations' 'Glamour-Tests-EyeSee' 'Glamour-Tests-Mondrian' 'Glamour-Tests-Core' 'Glamour-Morphic-Widgets' 'Glamour-EyeSee-Presentations' 'Glamour-Examples' 'Glamour-Tests-Morphic' 'Glamour-Helpers' 'Glamour-Magritte-Presentations').
	
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies-Not Working' stamp: 'SantiagoVidal 2/1/2012 14:10'!
graphicsCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('Graphics-Primitives' 'Graphics-Display Objects' 'Graphics-External-Ffenestri' 'Graphics-Files' 'Graphics-Text' 'Graphics-Transformations' 'Graphics-Fonts' 'Graphics-Support-Display Objects' 'Graphics-Tests-Files' 'Graphics-Tests-Primitives' 'Graphics-Tests-Text').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies-Not Working' stamp: 'SantiagoVidal 2/1/2012 10:47'!
hapaoCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Spy'; 
	package: 'ConfigurationOfSpy';load.
	(Smalltalk at: #ConfigurationOfSpy) project lastVersion load."
	
	packageRegularExpression:="'Spy-*'"nil.
	explicitPackages:=#('Spy-HapaoTestCoverage' 'Spy-HapaoTestCoverage-Simulator').
	
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 1/28/2012 13:35'!
kumpelCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('Kumpel-Core' 'Kumpel-Importer' 'Kumpel-Tests-Core' 'Kumpel-Tests-Importer').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies-Not Working' stamp: 'SantiagoVidal 2/1/2012 14:04'!
magritteCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('Magritte-Model-Core' 'Magritte-Morph-Model' 'Magritte-Model-Accessor' 'Magritte-Pharo-Model' 'Magritte-Model-Description' 'Magritte-Model-Exception' 'Magritte-Model-Memento' 'Magritte-Model-Models'  'Magritte-Tests-Model-Accessor' 'Magritte-Model-Utility' 'Magritte-Model-Visitor' 'Magritte-Tests-Model-Core' 'Magritte-Tests-Model-Description' 'Magritte-Tests-Model-Memento' 'Magritte-Tests-Model-Mocks' 'Magritte-Tests-Model-Models' 'Magritte-Tests-Model-Utility').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies-Not Working' stamp: 'SantiagoVidal 2/1/2012 10:07'!
merlinCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Merlin'; 
	package: 'ConfigurationOfMerlin';load.
	(Smalltalk at: #ConfigurationOfMerlin) project lastVersion load."
	
	packageRegularExpression:="'Merlin-*'"nil.
	explicitPackages:=#('Merlin-Core' 'Merlin-Examples' 'Merlin-Panes' 'Merlin-Parts' 'Merlin-PartsLayout' 'Merlin-Rendering' 'Merlin-Tests').
	
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 1/28/2012 13:06'!
metanolCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:=nil.
	explicitPackages:=#('Metanool-Core' 'Metanool-Tests-Core').
	
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 1/28/2012 12:16'!
mondrianCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Mondrian'; 
	package: 'ConfigurationOfMondrian';
	load.
(Smalltalk at: #ConfigurationOfMondrian) project lastVersion load."
	
	packageRegularExpression:="'Mondrian-*'"nil.
	explicitPackages:=#('Mondrian-Help-Tests' 'Mondrian-ComplexShape' 'Mondrian-Core' 'Mondrian-Normalizers' 'Mondrian-FADELayout' 'Mondrian-Pharo-Morphic' 'Mondrian-Shapes' 'Mondrian-Layouts-Tests' 'Mondrian-ShapeVisitor' 'Mondrian-Easel' 'Mondrian-Pharo-Tests' 'Mondrian-Help' 'Mondrian-Events' 'Mondrian-Example' 'Mondrian-Tests' 'Mondrian-Example-Tests' 'Mondrian-FADELayout-Tests' 'Mondrian-Util' 'Mondrian-Layouts' 'Mondrian-Visitor').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies-Not Working' stamp: 'SantiagoVidal 2/1/2012 11:02'!
mooseCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Moose-*'"nil.
	explicitPackages:=#('Moose-Core' 'Moose-Tests-Core').
	
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies-Not Working' stamp: 'SantiagoVidal 2/1/2012 13:49'!
morphicCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('Morphic-Text Support' 'Morphic-Events' 'Morphic-Widgets' 'Morphic-Pluggable Widgets' 'Morphic-Basic' 'Morphic-Support' 'Morphic-New Text Support' 'Morphic-Borders' 'Morphic-Layouts' 'Morphic-Explorer' 'Morphic-Windows' 'Morphic-DockingBar' 'Morphic-Balloon' 'Morphic-Worlds' 'Morphic-Menus' 'Morphic-MorphTreeWidget-Examples' 'Morphic-Kernel' 'Morphic-TrueType' 'Morphic-MorphTreeWidget' 'Morphic-WindowNotification' 'MorphicTests-Basic' 'MorphicTests-Kernel' 'MorphicTests-Text Support' 'MorphicTests-Widgets' 'MorphicTests-WindowNotification').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 2/1/2012 13:34'!
ocompletionCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('Ocompletion' 'Ocompletion-ECModel' 'Ocompletion-ECSqueak' 'Ocompletion-ECView' 'OcompletionTests').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'calculation' stamp: 'SantiagoVidal 2/1/2012 15:19'!
printComplexityValues
	|classes|
	classes:=mooseModel allClasses select: [:each | each isStub not].
	Transcript show: 'Number of classes: ', (classes size) asString;cr.
	Transcript show: 'LOC: ', (classes totalNumberOfLinesOfCode) asString;cr.! !

!MooseEACaseStudy methodsFor: 'calculation' stamp: 'SantiagoVidal 3/5/2012 15:57'!
printResults
	Transcript show: 'Percentage of Test coverage',((HapaoTestCoverage runTestsForPackages: packages"runTestsForPackagesMatching: packageRegularExpression") coverage)asString,'%';cr.
	Transcript show: 'Percentage of Dependences removed ',(100-((averageOfCandidates2nd*100)/averageOfCandidates1st))asString,'%';cr.
	Transcript show: 'Average of Candidates before refinent ',(averageOfCandidates1st)asString;cr.
	Transcript show: 'Average of Candidates after refinent ',(averageOfCandidates2nd)asString;cr.
	Transcript show: 'Average of false positives for invocation before refinent ',(averageOfFalsePositivesForInvocation1st)asString;cr.
	Transcript show: 'Average of false positives for invocation after refinent ',(averageOfFalsePositivesForInvocation2nd)asString;cr.
	Transcript show: 'Average of Outgoing Invocations By Method ',(averageOfOutgoingInvocationsByMethod)asString;cr.
	
	self printComplexityValues.
	
	! !

!MooseEACaseStudy methodsFor: 'caseStudies-Not Working' stamp: 'SantiagoVidal 2/1/2012 13:32'!
refactoringCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('Refactoring-Changes' 'Refactoring-Core-Conditions' 'Refactoring-Core-Model' 'Refactoring-Core-Refactorings' 'Refactoring-Core-Support' 'Refactoring-Critics' 'Refactoring-Critics-BlockRules' 'Refactoring-Critics-ParseTreeRules' 'Refactoring-Critics-TransformationRules' 'Refactoring-Environment' 'Refactoring-Spelling' 'Refactoring-Tests-Changes' 'Refactoring-Tests-Core' 'Refactoring-Tests-Core-Data' 'Refactoring-Tests-Critics' 'Refactoring-Tests-Environment' 'Refactoring-Tests-Spelling'.).
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 2/1/2012 12:41'!
regexCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('Regex-Core' 'Regex-Core-Exceptions' 'Regex-Help' 'Regex-Tests-Core').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 3/4/2012 19:00'!
roassalCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('Roassal-Core' 'Roassal-Core-Tests' 'Roassal-Event' 'Roassal-Interaction' 'Roassal-Interaction-Tests' 'Roassal-Example' 'Roassal-Morphic' 'Roassal-Morphic-Tests' 'Roassal-Actions' 'Roassal-Layout' 'Roassal-Builder' 'Roassal-Layout-Tests' 'Roassal-Builder-Tests' 'Roassal-Visitor' 'Roassal-Visitor-Tests' 'Roassal-Benchmarks').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 2/1/2012 12:37'!
roelTyperCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('RoelTyper-Core' 'RoelTyper-Pharo' 'RoelTyper-Squeak' 'RoelTyper-Tests').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'calculation' stamp: 'SantiagoVidal 2/1/2012 14:50'!
runAllCaseStudies
	Transcript show: 'Results of arkiCaseStudy ';cr.
	self arkiCaseStudy.
	Transcript show: 'Results of autoTestCaseStudy ';cr.
	self autoTestCaseStudy.
	Transcript show: 'Results of eyeSeeCaseStudy ';cr.
	self eyeSeeCaseStudy.
	Transcript show: 'Results of fameCaseStudy ';cr.
	self fameCaseStudy.
	Transcript show: 'Results of famixCaseStudy ';cr.
	self famixCaseStudy.
	Transcript show: 'Results of finderCaseStudy ';cr.
	self finderCaseStudy.
	Transcript show: 'Results of fsCaseStudy ';cr.
	self fsCaseStudy.
	Transcript show: 'Results of fuelContainerCaseStudy ';cr.
	self fuelContainerCaseStudy.
	Transcript show: 'Results of fuelProgressUpdateCaseStudy ';cr.
	self fuelProgressUpdateCaseStudy.
	Transcript show: 'Results of glamoroustCaseStudy ';cr.
	self glamoroustCaseStudy.
	Transcript show: 'Results of glamourCaseStudy ';cr.
	self glamourCaseStudy.
	Transcript show: 'Results of kumpelCaseStudy ';cr.
	self kumpelCaseStudy.
	Transcript show: 'Results of metanolCaseStudy ';cr.
	self metanolCaseStudy.
	Transcript show: 'Results of mondrianCaseStudy ';cr.
	self mondrianCaseStudy.
	Transcript show: 'Results of ocompletionCaseStudy ';cr.
	self ocompletionCaseStudy.
	Transcript show: 'Results of regexCaseStudy ';cr.
	self regexCaseStudy.
	Transcript show: 'Results of roassalCaseStudy ';cr.
	self roassalCaseStudy.
	Transcript show: 'Results of roelTyperCaseStudy ';cr.
	self roelTyperCaseStudy.
	Transcript show: 'Results of smallDudeCaseStudy ';cr.
	self smallDudeCaseStudy.
	Transcript show: 'Results of zincCaseStudy ';cr.
	self zincCaseStudy.


! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 1/28/2012 13:19'!
smallDudeCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('SmallDude-Core' 'SmallDude-Species' 'SmallDude-Tests-Core' 'SmallDude-Tests-Text' 'SmallDude-Text' 'SmallDude-Utils').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies-Not Working' stamp: 'SantiagoVidal 2/1/2012 10:45'!
spyCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Spy'; 
	package: 'ConfigurationOfSpy';load.
	(Smalltalk at: #ConfigurationOfSpy) project lastVersion load."
	
	packageRegularExpression:="'Spy-*'"nil.
	explicitPackages:=#('Spy-Core' "'Spy-HapaoTestCoverage'" 'Spy-Hip'" 'Spy-KaiProfiler' 'Spy-KaiProfiler-Tests' 'Spy-KeriTypeFeedback'" "'Spy-MemoryProfiler' 'Spy-MemoryProfiler-Tests'" 'Spy-ScenarioExample' 'Spy-Test' 'Spy-UI' 'Spy-Util' "'Spy-Compteur' "'Spy-HealthReport' 'Spy-CheckConstantMethods' 'Spy-Hip-MondrianShape' 'Spy-Documentor' 'Spy-Vitesse' 'Spy-ProfilingObject' 'Spy-ObjectProfilingNSMM' 'Spy-ObjectProfilingNDR' "'Spy-HapaoTestCoverage-Simulator'").
	
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies-Not Working' stamp: 'SantiagoVidal 2/1/2012 11:21'!
sunitCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('SUnit-Core-Announcements' 'SUnit-Core-Extensions' 'SUnit-Core-Kernel' 'SUnit-Core-Utilities' 'SUnit-Help' 'SUnit-Tests-Core' 'SUnit-UI').
	self calculate.! !

!MooseEACaseStudy methodsFor: 'caseStudies' stamp: 'SantiagoVidal 2/1/2012 11:08'!
zincCaseStudy
	"Load the project"
	"Gofer new
	squeaksource: 'Roassal'; 
	package: 'ConfigurationOfRoassal';load.
	(Smalltalk at: #ConfigurationOfRoassal) project lastVersion load."
	
	packageRegularExpression:="'Roassal-*'"nil.
	explicitPackages:=#('Zinc-HTTP-Client-Server' 'Zinc-HTTP-Core' 'Zinc-HTTP-Exceptions' 'Zinc-HTTP-Logging' 'Zinc-HTTP-Streaming' 'Zinc-HTTP-Support' 'Zinc-Tests').
	self calculate.! !

Object subclass: #NiceGUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!NiceGUI methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:39'!
drawOn: aCanvas
	Button new drawOn: aCanvas.! !

Object subclass: #Widget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

Widget subclass: #Button
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!Button methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:37'!
drawOn: aCanvas
	"Drawing a button"! !

!Widget methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:37'!
drawOn: aCanvas
	self subclassResponsibility.! !

Widget subclass: #Window
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MooseExecutionAnalyzer-TestsScenarios'!

!Window methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 1/22/2012 13:38'!
drawOn: aCanvas
	"Drawing a window"! !
